/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
	"time"
)

// ProductOrderDeleteEvent The notification data structure
type ProductOrderDeleteEvent struct {
	// Identifier of the Process flow
	Id *string `json:"id,omitempty"`
	// Reference of the ProcessFlow
	Href *string `json:"href,omitempty"`
	// The identifier of the notification.
	EventId *string `json:"eventId,omitempty"`
	// Time of the event occurrence.
	EventTime *time.Time `json:"eventTime,omitempty"`
	// The type of the notification.
	EventType *string `json:"eventType,omitempty"`
	// The correlation id for this event.
	CorrelationId *string `json:"correlationId,omitempty"`
	// The domain of the event.
	Domain *string `json:"domain,omitempty"`
	// The title of the event.
	Title *string `json:"title,omitempty"`
	// An explnatory of the event.
	Description *string `json:"description,omitempty"`
	// A priority.
	Priority *string `json:"priority,omitempty"`
	// The time the event occured.
	TimeOcurred *time.Time `json:"timeOcurred,omitempty"`
	Event *ProductOrderDeleteEventPayload `json:"event,omitempty"`
}

// NewProductOrderDeleteEvent instantiates a new ProductOrderDeleteEvent object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProductOrderDeleteEvent() *ProductOrderDeleteEvent {
	this := ProductOrderDeleteEvent{}
	return &this
}

// NewProductOrderDeleteEventWithDefaults instantiates a new ProductOrderDeleteEvent object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProductOrderDeleteEventWithDefaults() *ProductOrderDeleteEvent {
	this := ProductOrderDeleteEvent{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *ProductOrderDeleteEvent) SetId(v string) {
	o.Id = &v
}

// GetHref returns the Href field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetHref() string {
	if o == nil || o.Href == nil {
		var ret string
		return ret
	}
	return *o.Href
}

// GetHrefOk returns a tuple with the Href field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetHrefOk() (*string, bool) {
	if o == nil || o.Href == nil {
		return nil, false
	}
	return o.Href, true
}

// HasHref returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasHref() bool {
	if o != nil && o.Href != nil {
		return true
	}

	return false
}

// SetHref gets a reference to the given string and assigns it to the Href field.
func (o *ProductOrderDeleteEvent) SetHref(v string) {
	o.Href = &v
}

// GetEventId returns the EventId field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetEventId() string {
	if o == nil || o.EventId == nil {
		var ret string
		return ret
	}
	return *o.EventId
}

// GetEventIdOk returns a tuple with the EventId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetEventIdOk() (*string, bool) {
	if o == nil || o.EventId == nil {
		return nil, false
	}
	return o.EventId, true
}

// HasEventId returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasEventId() bool {
	if o != nil && o.EventId != nil {
		return true
	}

	return false
}

// SetEventId gets a reference to the given string and assigns it to the EventId field.
func (o *ProductOrderDeleteEvent) SetEventId(v string) {
	o.EventId = &v
}

// GetEventTime returns the EventTime field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetEventTime() time.Time {
	if o == nil || o.EventTime == nil {
		var ret time.Time
		return ret
	}
	return *o.EventTime
}

// GetEventTimeOk returns a tuple with the EventTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetEventTimeOk() (*time.Time, bool) {
	if o == nil || o.EventTime == nil {
		return nil, false
	}
	return o.EventTime, true
}

// HasEventTime returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasEventTime() bool {
	if o != nil && o.EventTime != nil {
		return true
	}

	return false
}

// SetEventTime gets a reference to the given time.Time and assigns it to the EventTime field.
func (o *ProductOrderDeleteEvent) SetEventTime(v time.Time) {
	o.EventTime = &v
}

// GetEventType returns the EventType field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetEventType() string {
	if o == nil || o.EventType == nil {
		var ret string
		return ret
	}
	return *o.EventType
}

// GetEventTypeOk returns a tuple with the EventType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetEventTypeOk() (*string, bool) {
	if o == nil || o.EventType == nil {
		return nil, false
	}
	return o.EventType, true
}

// HasEventType returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasEventType() bool {
	if o != nil && o.EventType != nil {
		return true
	}

	return false
}

// SetEventType gets a reference to the given string and assigns it to the EventType field.
func (o *ProductOrderDeleteEvent) SetEventType(v string) {
	o.EventType = &v
}

// GetCorrelationId returns the CorrelationId field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetCorrelationId() string {
	if o == nil || o.CorrelationId == nil {
		var ret string
		return ret
	}
	return *o.CorrelationId
}

// GetCorrelationIdOk returns a tuple with the CorrelationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetCorrelationIdOk() (*string, bool) {
	if o == nil || o.CorrelationId == nil {
		return nil, false
	}
	return o.CorrelationId, true
}

// HasCorrelationId returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasCorrelationId() bool {
	if o != nil && o.CorrelationId != nil {
		return true
	}

	return false
}

// SetCorrelationId gets a reference to the given string and assigns it to the CorrelationId field.
func (o *ProductOrderDeleteEvent) SetCorrelationId(v string) {
	o.CorrelationId = &v
}

// GetDomain returns the Domain field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetDomain() string {
	if o == nil || o.Domain == nil {
		var ret string
		return ret
	}
	return *o.Domain
}

// GetDomainOk returns a tuple with the Domain field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetDomainOk() (*string, bool) {
	if o == nil || o.Domain == nil {
		return nil, false
	}
	return o.Domain, true
}

// HasDomain returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasDomain() bool {
	if o != nil && o.Domain != nil {
		return true
	}

	return false
}

// SetDomain gets a reference to the given string and assigns it to the Domain field.
func (o *ProductOrderDeleteEvent) SetDomain(v string) {
	o.Domain = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetTitle() string {
	if o == nil || o.Title == nil {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetTitleOk() (*string, bool) {
	if o == nil || o.Title == nil {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasTitle() bool {
	if o != nil && o.Title != nil {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *ProductOrderDeleteEvent) SetTitle(v string) {
	o.Title = &v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *ProductOrderDeleteEvent) SetDescription(v string) {
	o.Description = &v
}

// GetPriority returns the Priority field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetPriority() string {
	if o == nil || o.Priority == nil {
		var ret string
		return ret
	}
	return *o.Priority
}

// GetPriorityOk returns a tuple with the Priority field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetPriorityOk() (*string, bool) {
	if o == nil || o.Priority == nil {
		return nil, false
	}
	return o.Priority, true
}

// HasPriority returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasPriority() bool {
	if o != nil && o.Priority != nil {
		return true
	}

	return false
}

// SetPriority gets a reference to the given string and assigns it to the Priority field.
func (o *ProductOrderDeleteEvent) SetPriority(v string) {
	o.Priority = &v
}

// GetTimeOcurred returns the TimeOcurred field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetTimeOcurred() time.Time {
	if o == nil || o.TimeOcurred == nil {
		var ret time.Time
		return ret
	}
	return *o.TimeOcurred
}

// GetTimeOcurredOk returns a tuple with the TimeOcurred field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetTimeOcurredOk() (*time.Time, bool) {
	if o == nil || o.TimeOcurred == nil {
		return nil, false
	}
	return o.TimeOcurred, true
}

// HasTimeOcurred returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasTimeOcurred() bool {
	if o != nil && o.TimeOcurred != nil {
		return true
	}

	return false
}

// SetTimeOcurred gets a reference to the given time.Time and assigns it to the TimeOcurred field.
func (o *ProductOrderDeleteEvent) SetTimeOcurred(v time.Time) {
	o.TimeOcurred = &v
}

// GetEvent returns the Event field value if set, zero value otherwise.
func (o *ProductOrderDeleteEvent) GetEvent() ProductOrderDeleteEventPayload {
	if o == nil || o.Event == nil {
		var ret ProductOrderDeleteEventPayload
		return ret
	}
	return *o.Event
}

// GetEventOk returns a tuple with the Event field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProductOrderDeleteEvent) GetEventOk() (*ProductOrderDeleteEventPayload, bool) {
	if o == nil || o.Event == nil {
		return nil, false
	}
	return o.Event, true
}

// HasEvent returns a boolean if a field has been set.
func (o *ProductOrderDeleteEvent) HasEvent() bool {
	if o != nil && o.Event != nil {
		return true
	}

	return false
}

// SetEvent gets a reference to the given ProductOrderDeleteEventPayload and assigns it to the Event field.
func (o *ProductOrderDeleteEvent) SetEvent(v ProductOrderDeleteEventPayload) {
	o.Event = &v
}

func (o ProductOrderDeleteEvent) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	if o.Href != nil {
		toSerialize["href"] = o.Href
	}
	if o.EventId != nil {
		toSerialize["eventId"] = o.EventId
	}
	if o.EventTime != nil {
		toSerialize["eventTime"] = o.EventTime
	}
	if o.EventType != nil {
		toSerialize["eventType"] = o.EventType
	}
	if o.CorrelationId != nil {
		toSerialize["correlationId"] = o.CorrelationId
	}
	if o.Domain != nil {
		toSerialize["domain"] = o.Domain
	}
	if o.Title != nil {
		toSerialize["title"] = o.Title
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if o.Priority != nil {
		toSerialize["priority"] = o.Priority
	}
	if o.TimeOcurred != nil {
		toSerialize["timeOcurred"] = o.TimeOcurred
	}
	if o.Event != nil {
		toSerialize["event"] = o.Event
	}
	return json.Marshal(toSerialize)
}

type NullableProductOrderDeleteEvent struct {
	value *ProductOrderDeleteEvent
	isSet bool
}

func (v NullableProductOrderDeleteEvent) Get() *ProductOrderDeleteEvent {
	return v.value
}

func (v *NullableProductOrderDeleteEvent) Set(val *ProductOrderDeleteEvent) {
	v.value = val
	v.isSet = true
}

func (v NullableProductOrderDeleteEvent) IsSet() bool {
	return v.isSet
}

func (v *NullableProductOrderDeleteEvent) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProductOrderDeleteEvent(val *ProductOrderDeleteEvent) *NullableProductOrderDeleteEvent {
	return &NullableProductOrderDeleteEvent{value: val, isSet: true}
}

func (v NullableProductOrderDeleteEvent) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProductOrderDeleteEvent) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


